/////////////////////////////////////////////////////////////////////////////
//// INCLUDE FILES

#ifndef __SNTRANS_H__
#define __SNTRANS_H__

#define  USE_NDIS
#include <vtoolsc.h>

// Copyright And Configuration Management ----------------------------------
//
//   Header For NDIS 3.X Network Protocol (Transport) Example - SNTRANS.h
//
//     Copyright (c) 1995-1997, Printing Communications Associates, Inc.
//
//                             Thomas F. Divine
//                           4201 Brunswick Court
//                        Smyrna, Georgia 30080 USA
//                              (770) 436-1714
//
// $Workfile$
//  $Logfile$
//   $Author: FRED $
//     $Date: 1995/11/28 08:35:43 $
// $Revision: 1.1 $
//
// $Log: SNTRANS.h $
// Revision 1.1  1995/11/28 08:35:43  FRED
// Initial revision
// 
// End ---------------------------------------------------------------------


/////////////////////////////////////////////////////////////////////////////
//// VXD DEVICE INFORMATION

/* No Unique VxD Device ID
--------------------------
 * A unique VxD ID is only required if it is necessary to export the
 * protocol's Service Table for use by other VxD's.
 */
#define SNTRANS_DEVICE_ID	UNDEFINED_DEVICE_ID

/* Problems With NDIS_Init_Order Definition
-------------------------------------------
 * NDIS_Init_Order is defined correctly in VtoolsD V2.04, but not in prior
 * versions.
 */
#ifndef NDIS_Init_Order
#define NDIS_Init_Order         0x02000 + VNETBIOS_INIT_ORDER
#endif

#define MAC_Init_Order          0x02000 + NDIS_Init_Order
#define PROTOCOL_Init_Order     0x02000 + MAC_Init_Order

#define SNTRANS_Major		1
#define SNTRANS_Minor		0
#define SNTRANS_DeviceID	SNTRANS_DEVICE_ID
#define SNTRANS_Init_Order	PROTOCOL_Init_Order


#define SNTRANS_NDIS_MAJOR_VERSION	0x03

#ifdef WIN40
#define SNTRANS_NDIS_MINOR_VERSION	0x0A
#else
#define SNTRANS_NDIS_MINOR_VERSION	0x00
#endif

#define TRANSPORT_NAME "SNTRANS"

/////////////////////////////////////////////////////////////////////////////
//// NDIS 3.1 PROTOCOL FUNCTION PROTOTYPES

// These functions are implemented in TRANSFCN.C.

VOID NDIS_API
SNTRANSOpenAdapterCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN NDIS_STATUS Status,
    IN NDIS_STATUS OpenErrorStatus
    );

VOID NDIS_API
SNTRANSCloseAdapterCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN NDIS_STATUS Status
    );

VOID NDIS_API
SNTRANSSendCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN PNDIS_PACKET Packet,
    IN NDIS_STATUS Status
    );

VOID NDIS_API
SNTRANSTransferDataCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN PNDIS_PACKET Packet,
    IN NDIS_STATUS Status,
    IN UINT BytesTransferred
    );

VOID NDIS_API
SNTRANSResetCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN NDIS_STATUS Status
    );

VOID NDIS_API
SNTRANSRequestCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN PNDIS_REQUEST NdisRequest,
    IN NDIS_STATUS Status
    );

NDIS_STATUS NDIS_API
SNTRANSReceiveHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN NDIS_HANDLE MacReceiveContext,
    IN PVOID HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookAheadBuffer,
    IN UINT LookaheadBufferSize,
    IN UINT PacketSize
    );

VOID NDIS_API
SNTRANSReceiveCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext
    );

VOID NDIS_API
SNTRANSStatusHandler(
    IN NDIS_HANDLE NdisBindingContext,
    IN NDIS_STATUS GeneralStatus,
    IN PVOID StatusBuffer,
    IN UINT StatusBufferSize
    );

VOID NDIS_API
SNTRANSStatusCompleteHandler(
    IN NDIS_HANDLE NdisBindingContext
    );


//
// BIND_ADAPTER_HANDLER, UNBIND_ADAPTER_HANDLER, UNLOAD_PROTOCOL
// are valid for NDIS 3.1 protocols
//

VOID NDIS_API
SNTRANSBindAdapterHandler(
    OUT PNDIS_STATUS    pStatus,
    IN  NDIS_HANDLE     BindAdapterContext,
    IN  PNDIS_STRING    AdapterName,
    IN  PVOID           SystemSpecific1,
    IN  PVOID           SystemSpecific2
    );


VOID NDIS_API
SNTRANSUnbindAdapterHandler(
    OUT PNDIS_STATUS    pStatus,
    IN  NDIS_HANDLE     ProtocolBindingContext,
    IN  NDIS_HANDLE     UnbindAdapterContext
    );

VOID NDIS_API SNTRANSUnloadProtocolHandler( void );



/////////////////////////////////////////////////////////////////////////////
//// PROTOCOL CONTEXT

// Only have one of these structures for the Protocol VxD.

typedef
struct _PROTOCOL_BLOCK
{
	/* NDIS Binding Context
	----------------------- */
	NDIS_HANDLE hBindAdapterContext;     // Passed to BindAdapterHandler
	NDIS_HANDLE hNdisAdapterHandle;      // returned from NdisOpenAdapter
	NDIS_HANDLE hNdisProtocolHandle;     // returned from NdisRegisterProtocol

	NDIS_PROTOCOL_CHARACTERISTICS ProtocolCharacteristics;

	/* Open/Close Adapter Data
	-------------------------- */
	NDIS_STATUS nOpenAdapterStatus;
	NDIS_STATUS nOpenAdapterErrorStatus;
	UINT        nMedium;
	NDIS_MEDIUM MediumArray;
}
	PROTOCOL_BLOCK, *PPROTOCOL_BLOCK;

extern PROTOCOL_BLOCK SNTRANSContext;

#endif // __SNTRANS_H__
